import java.io.*;
/*
class MiscVars {
		int chbase_40;
		int chbase_20;
		int char_offset;
		int char_delta;
		int invert_mask;
		int blank_mask;
		int dmactl_xmin_noscroll;
		int dmactl_xmax_noscroll;
		int dmactl_xmin_scroll;
		int dmactl_xmax_scroll;

		int global_sizem;
		int global_sizep0;
		int global_sizep2;
		int global_sizep3;
		int global_sizep4;

		int PM_XPos[] = new int[256];
		int PM_Width[] = { 2, 4, 2, 8 };
}*/

class AtariMem extends Memory implements ESCCodes, AtariHardwareRegisters, AtariConstants {
		public final static int OS_A = 0;
		public final static int OS_B = 1;
		public final static int OS_XL = 2;
		public final static int HW = 3;		// memory type

		int [] under_atarixl_os = new int[16384];
		int [] under_atari_basic = new int[8192];
		
		int [] atarixl_os = new int[16384];
		int [] atari_basic = new int[8192];
		
		int chbase_40;
		int chbase_20;
		int char_offset;
		int char_delta;
		int invert_mask;
		int blank_mask;
		int dmactl_xmin_noscroll;
		int dmactl_xmax_noscroll;
		int dmactl_xmin_scroll;
		int dmactl_xmax_scroll;

		int global_sizem;
		int global_sizep0;
		int global_sizep1;
		int global_sizep2;
		int global_sizep3;

		int global_hposm0;
		int global_hposm1;
		int global_hposm2;
		int global_hposm3;

		int global_hposp0;
		int global_hposp1;
		int global_hposp2;
		int global_hposp3;
		
		
		int PM_XPos[] = new int[256];
		int PM_Width[] = { 2, 4, 2, 8 };

		int xmin, xmax;

		public HWArea hwreg = new HWArea();
		public AtariCustom atari_custom = new AtariCustom();
		

		private int SHIFT = 0x00;
		
		public String [] OS = {"./atariosa.rom", "./atariosb.rom", "./atarixl.rom"};
			// Files where OS is stored
		public String BASIC = new String ("./ataribas.rom");
			// File where the Atari Basic is stored.
		

		public int actualOS;
		
	/**
	 * Creates the new memory object for the Atari computer (processor).
	 * It also initializes the memory and turns the OS on, writing to
	 * hardware registers PORTA and PORTB the value 0xff.
	 *
	 */
		public AtariMem() {
				//super();
				installAtariOS(OS_XL);
				installBasic();
				patchOS();
				hwreg.PORTA = 0xff;		// this turns the OS on.
				hwreg.PORTB = 0xff;
				hwreg.CONSOL = 7;
/*				mem[53279] = 7;
				mem[0x244] = 1;*/
				
		}
		
		
		
		public void memcpy(int [] a1, int [] a2, int a1_displ, int a2_displ, int len) {
			for (int i=0; i<len; i++) 
					a1[a1_displ + i] = a2[a2_displ + i];
			}
		
		/*
		 * The right fun goes, here... Enjoy your Atari!
		 */
		 

	/**
	 *	 Yes, as mentioned elsewhere the Atari custom chips do NOT
	 * fuly decode their address, so this function do so.
	 *
	 * It access the hardware	registers.
	 *
	 * @param   address  address to access
	 * @return     the value from this address. 
	 */
		public int getByteAtari(int address) {
			int value = 0;
			
				// I think this part is really funny, because 
			  // (as you certainly see) some of theese custom
			  // chips don't fully decode their address (all
			  // but PIA if not connected in old Atari which 
			  // doesn't run XL/XE new OS). Really great fun!
			  switch (address & 0xff00)    {
    				case 0xd000:        // GTIA 
      				address &= 0xff1f;
      				break;
    				case 0xd200:        // POKEY
      				address &= 0xff0f;
      				break;
    				case 0xd300:        // PIA 
      				if (actualOS != OS_XL)
							address &= 0xff03;
      				break;
    				case 0xd400:        // ANTIC 
      					address &= 0xff0f;
      					break;
    				default:
      			break;
    			}

 				switch (address) {
    				case CHBASE :
      				value = hwreg.CHBASE;
      				break;
    				case CHACTL :
      				value = hwreg.CHACTL;
      				break;
    				case CONSOL :
      				value = atari_custom.AtariConsol();
      				break;
    				case DLISTL :
      				value = hwreg.DLISTL;
      				break;
    				case DLISTH :
      				value = hwreg.DLISTH;
      				break;
    				case DMACTL :
      				value = hwreg.DMACTL;
      				break;
    				case KBCODE :
      				value = hwreg.KBCODE;
      				break;
    				case IRQST :
      				value = hwreg.IRQST;
      				break;
    				case M0PF :
      				value = hwreg.M0PF;
      				break;
    				case M1PF :
      				value = hwreg.M1PF;
      				break;
    				case M2PF :
      				value = hwreg.M2PF;
      				break;
    				case M3PF :
      				value = hwreg.M3PF;
      				break;
    				case M0PL :
      				value = hwreg.M0PL;
      				break;
    				case M1PL :
      				value = hwreg.M1PL;
      				break;
    				case M2PL :
      				value = hwreg.M2PL;
      				break;
    				case M3PL :
      				value = hwreg.M3PL;
      				break;
    				case P0PF :
      				value = hwreg.P0PF;
      				break;
    				case P1PF :
      				value = hwreg.P1PF;
      				break;
    				case P2PF :
      				value = hwreg.P2PF;
      				break;
    				case P3PF :
      				value = hwreg.P3PF;
      				break;
    				case P0PL :
      				value = hwreg.P0PL & 0xfe;
      				break;
    				case P1PL :
      				value = hwreg.P1PL & 0xfd;
      				break;
    				case P2PL :
      				value = hwreg.P2PL & 0xfb;
      				break;
    				case P3PL :
      				value = hwreg.P3PL & 0xf7;
      				break;
    				case PENH :
    				case PENV :
      				value = 0x00;
      				break;
    				case PORTA :
      				value = atari_custom.AtariPort (0);
      				break;
    				case PORTB :
      				switch (actualOS) 	{
							case OS_A :
							case OS_B:	
	  							value = atari_custom.AtariPort (1);
	  							break;
							case OS_XL :
								value = hwreg.PORTB;
						//		System.out.println("read PORTB : "+value);
	  							break;
						}
      				break;
    				case POT0 :
      				value = atari_custom.AtariPOT (0);
      				break;
    				case POT1 :
      				value = atari_custom.AtariPOT (1);
      				break;
    				case POT2 :
      				value = atari_custom.AtariPOT (2);
      				break;
    				case POT3 :
      				value = atari_custom.AtariPOT (3); 
      				break;
    				case POT4 :
      				value = atari_custom.AtariPOT (4);
      				break;
    				case POT5 :
      				value = atari_custom.AtariPOT (5);
      				break;
    				case POT6 :
      				value = atari_custom.AtariPOT (6);
      				break;
    				case POT7 :
      				value = atari_custom.AtariPOT (7);
      				break;
    				case RANDOM :
      				value = atari_custom.AtariRand();
      				break;
    				case TRIG0 :
      				value = atari_custom.AtariTRIG (0);
      				break;
    				case TRIG1 :
      				value = atari_custom.AtariTRIG (1);
      				break;
    				case TRIG2 :
      				value = atari_custom.AtariTRIG (2);
      				break;
    				case TRIG3 :
      				value = atari_custom.AtariTRIG (3);
      				break;
    				case VCOUNT :
      				value = hwreg.VCOUNT++;
			       break;
    				case NMIEN :
      				value = hwreg.NMIEN;
      				break;
    				case NMIST :
      				value = hwreg.NMIST;
      				break;
    				case SKSTAT :
      				if (SHIFT != 0)
							value = 0x05;
      				else
							value = 0x0d;
      				break;
    				case WSYNC :
      				value = 0;
      				break;
    				default :
      				value = 0;
      				break;
    			}

  			return value;
	}

	

	/**
	 *	 This method deals with writing to the hardware registers.	
	 *
	 * @param   address  what hardware register to access
	 * @param   value  the value to store
	 */
	public void putByteAtari(int address, int value) {
		 switch (address & 0xff00)    {
    			case 0xd000:        /* GTIA */
      			address &= 0xff1f;
      			break;
    			case 0xd200:        /* POKEY */
      			address &= 0xff0f;
      			break;
    			case 0xd300:        /* PIA */
      			if (actualOS != OS_XL)
						address &= 0xff03;
      			break;
    			case 0xd400:        /* ANTIC */
      			address &= 0xff0f;
      			break;
    			default:
      			break;
    		}

  			switch (address)    {
    			case AUDC1 :
      			atari_custom.AtariAUDC (1, value);
      			break;
    			case AUDC2 :
      			atari_custom.AtariAUDC (2, value);
      			break;
    			case AUDC3 :
      			atari_custom.AtariAUDC (3, value);
      			break;
    			case AUDC4 :
      			atari_custom.AtariAUDC (4, value);
      			break;
    			case AUDCTL :
      			atari_custom.AtariAUDCTL (value);
      			break;
    			case AUDF1 :
      			atari_custom.AtariAUDF (1, value);
      			break;
    			case AUDF2 :
      			atari_custom.AtariAUDF (2, value);
      			break;
    			case AUDF3 :
      			atari_custom.AtariAUDF (3, value);
      			break;
    			case AUDF4 :
      			atari_custom.AtariAUDF (4, value);
      			break;
    			case CHBASE :
      			hwreg.CHBASE = value;
      			chbase_40 = (value << 8) & 0xfc00;
      			chbase_20 = (value << 8) & 0xfe00;
      			break;
    			case CHACTL :
      			hwreg.CHACTL = value;
	//   Check for vertical reflect, video invert and character blank bits
					switch ( mem[CHACTL] & 0x07) 	  {
	  					case 0x00 :
	    					char_offset = 0;
	    					char_delta = 1;
	    					invert_mask = 0x00;
	    					blank_mask = 0x00;
	    					break;
	  					case 0x01 :
	    					char_offset = 0;
	    					char_delta = 1;
	    					invert_mask = 0x00;
	    					blank_mask = 0x80;
	    					break;
	  					case 0x02 :
	    					char_offset = 0;
	    					char_delta = 1;
	    					invert_mask = 0x80;
	    					blank_mask = 0x00;
	    					break;
	  					case 0x03 :
	    					char_offset = 0;
	    					char_delta = 1;
	    					invert_mask = 0x80;
	    					blank_mask = 0x80;
	    					break;
	  					case 0x04 :
	    					char_offset = 7;
	    					char_delta = -1;
	    					invert_mask = 0x00;
	    					blank_mask = 0x00;
	    					break;
	  					case 0x05 :
	    					char_offset = 7;
	    					char_delta = -1;
	    					invert_mask = 0x00;
	    					blank_mask = 0x80;
	    					break;
	  					case 0x06 :
	    					char_offset = 7;
	    					char_delta = -1;
	    					invert_mask = 0x80;
	    					blank_mask = 0x00;
	    					break;
	  					case 0x07 :
	    					char_offset = 7;
	    					char_delta = -1;
	    					invert_mask = 0x80;
	    					blank_mask = 0x80;
	    					break;
	  				}
					break;
    			case COLBK :
      			hwreg.COLBK = value;
      			break;
    			case COLPF0 :
      			hwreg.COLPF0 = value;
      			break;
    			case COLPF1 :
      			hwreg.COLPF1 = value;
      			break;
    			case COLPF2 :
      			hwreg.COLPF2 = value;
      			break;
    			case COLPF3 :
      			hwreg.COLPF3 = value;
      			break;
    			case COLPM0 :
      			hwreg.COLPM0 = value;
      			break;
    			case COLPM1 :
      			hwreg.COLPM1 = value;
      			break;
    			case COLPM2 :
      			hwreg.COLPM2 = value;
      			break;
    			case COLPM3 :
      			hwreg.COLPM3 = value;
      			break;
    			case CONSOL :
    				hwreg.CONSOL = value;
      			break;
    			case DLISTL :
      			hwreg.DLISTL = value;
      			break;
    			case DLISTH :
      			hwreg.DLISTH = value;
      			break;
    			case DMACTL :
      			hwreg.DMACTL = value;
					switch (hwreg.DMACTL & 0x03)  {
	  					case 0x00 :
	    					dmactl_xmin_noscroll = dmactl_xmax_noscroll = 0;
	    					dmactl_xmin_scroll = dmactl_xmax_scroll = 0;
	    					break;
	  					case 0x01 :
	    					dmactl_xmin_noscroll = 64;
	   					dmactl_xmax_noscroll = ATARI_WIDTH - 64;
	    					dmactl_xmin_scroll = 32;
	    					dmactl_xmax_scroll = ATARI_WIDTH - 32;
	    					break;
	  					case 0x02 :
	    					dmactl_xmin_noscroll = 32;
	    					dmactl_xmax_noscroll = ATARI_WIDTH - 32;
	    					dmactl_xmin_scroll = 0;
	    					dmactl_xmax_scroll = ATARI_WIDTH;
	    					break;
	  					case 0x03 :
	    					dmactl_xmin_noscroll = dmactl_xmin_scroll = 0;
	    					dmactl_xmax_noscroll = dmactl_xmax_scroll = ATARI_WIDTH;
	    					break;
	  				}
					break;
    			case GRAFM :
      			hwreg.GRAFM = value;
      			break;
    			case GRAFP0 :
      			hwreg.GRAFP0 = value;
      			break;
    			case GRAFP1 :
      			hwreg.GRAFP1 = value;
      			break;
    			case GRAFP2 :
      			hwreg.GRAFP2 = value;
      			break;
    			case GRAFP3 :
      			hwreg.GRAFP3 = value;
      			break;
    			case HITCLR :
      			hwreg.M0PF = hwreg.M1PF = hwreg.M2PF = hwreg.M3PF = 0;
      			hwreg.P0PF = hwreg.P1PF = hwreg.P2PF = hwreg.P3PF = 0; 
      			hwreg.M0PL = hwreg.M1PL = hwreg.M2PL = hwreg.M3PL = 0; 
      			hwreg.P0PL = hwreg.P1PL = hwreg.P2PL = hwreg.P3PL = 0;
      			break;
    			case HPOSM0 :
      			global_hposm0 = PM_XPos[value];
      			hwreg.HPOSM0 = value;
      			break;
    			case HPOSM1 :
      			global_hposm1 = PM_XPos[value];
      			hwreg.HPOSM1 = value;
      			break;
    			case HPOSM2 :
      			global_hposm2 = PM_XPos[value];
      			hwreg.HPOSM2 = value;
      			break;
    			case HPOSM3 :
      			global_hposm3 = PM_XPos[value];
      			hwreg.HPOSM3 = value;
      			break;
    			case HPOSP0 :
      			global_hposp0 = PM_XPos[value];
      			hwreg.HPOSP0 = value;
      			break;
    			case HPOSP1 :
      			global_hposp1 = PM_XPos[value];
      			hwreg.HPOSP1 = value;
      			break;
    			case HPOSP2 :
      			global_hposp2 = PM_XPos[value];
      			hwreg.HPOSP2 = value;
      			break;
    			case HPOSP3 :
      			global_hposp3 = PM_XPos[value];
      			hwreg.HPOSP3 = value;
      			break;
    			case HSCROL :
      			hwreg.HSCROL = value & 0x0f;
      			break;
    			case IRQEN :
      			hwreg.IRQST |= (~value) & 0xff;
      			hwreg.IRQEN = value;
      			break;
    			case NMIEN :
      			hwreg.NMIEN = value;
      			break;
    			case NMIRES :
      			hwreg.NMIRES = 0;
      			break;
    			case PMBASE :
      			hwreg.PMBASE = value;
      			break;
    			case PORTB :
					// System.out.println("PORTB : "+value);
					if (((value ^ hwreg.PORTB) & 0x01) != 0) {
						if ((value & 0x01) != 0)	{
							System.out.println("Disabling 0xc000-0xd800 (ROM)");
							memcpy (under_atarixl_os, mem, 0x0000, 0xc000, 0x1000);
							memcpy (under_atarixl_os, mem, 0x1800, 0xd800, 0x2800);
							memcpy (mem, atarixl_os, 0xc000, 0x0000, 0x1000);
							memcpy (mem, atarixl_os, 0xd800, 0x1800, 0x2800);
							setROM (0xc000, 0xcfff);
							setROM (0xd800, 0xffff);
						} else {
							System.out.println("Enabling 0xc000-0xd800 (RAM)");
							memcpy (mem, under_atarixl_os, 0xc000, 0x0000, 0x1000);
							memcpy (mem, under_atarixl_os, 0xd800, 0x1800, 0x2800);
							setRAM (0xc000, 0xcfff);
							setRAM (0xd800, 0xffff);
						}
					}
	    				
	    				
					if (((value ^ hwreg.PORTB) & 0x02) != 0) {
						if ((value & 0x02) != 0) {
							System.out.println("Disabling BASIC (RAM)");
							memcpy (mem, under_atari_basic, 0xa000, 0x0000, 0x2000);
							setRAM (0xa000, 0xbfff);
						} else {
							System.out.println("Enabling BASIC (ROM)");
							memcpy (under_atari_basic, mem, 0x0000,0xa000, 0x2000);
							memcpy (mem, atari_basic, 0xa000, 0x0000, 0x2000);
							System.out.println("****0xbffc:"+atari_basic[0x1ffc]);
							setROM (0xa000, 0xbfff);
						}
					}
	      

					if (((value ^ hwreg.PORTB) & 0x80) != 0)  {
						if ((value & 0x80) != 0)	{
							System.out.println("Enabling 0x5000-0x5800 (RAM)");
							memcpy (mem, under_atarixl_os, 0x5000, 0x1000, 0x0800);
							setRAM (0x5000, 0x57ff);
						} else {
							System.out.println("Disabling 0x5000-0x5800 (ROM)");
							memcpy (under_atarixl_os, mem, 0x1000, 0x5000, 0x800);
							memcpy (mem, atarixl_os, 0x5000, 0x1000, 0x800);
							setROM (0x5000, 0x57ff);
						}
					}
					hwreg.PORTB = value;
					break;
    			case POTGO :
      				break;
    			case PRIOR :
//     				if (value != PRIOR) 	{
//						SetPrior (value);
//					}
      			break;
    			case SIZEM :
      				global_sizem = PM_Width[value & 0x03];
      				hwreg.SIZEM = value;
      				break;
    			case SIZEP0 :
					global_sizep0 = PM_Width[value & 0x03];
      				hwreg.SIZEP0 = value;
      				break;
    			case SIZEP1 :
      				global_sizep1 = PM_Width[value & 0x03];
      			hwreg.SIZEP1 = value;
      			break;
    			case SIZEP2 :
      				global_sizep2 = PM_Width[value & 0x03];
      			hwreg.SIZEP2 = value;
      			break;
    			case SIZEP3 :
      				global_sizep3 = PM_Width[value & 0x03];
      			hwreg.SIZEP3 = value;
      			break;
    			case WSYNC :
      			break;
    			default :
    				break;
    		}
	}
		
		

	/**
	 * Use this function when you want to write into the memory as
	 * it is seen from the CPU. E.g. : ROM is not accessible for
	 * writing, safe writing to hardware registers, etc.
	 *
	 * @param   address  location for write
	 * @param   value  the value to store in the location
	 */
		public void putByte(int address, int value) {
		
			/*	
				if (address==243 || address == 836) {
					System.out.println("mov "+ address + "," + value);
				}

			*/
				if (attrib[address] == RAM) {
						mem[address] = value & 0xff;
				} else if (attrib[address] == HW) {
						putByteAtari(address, value);
				}
		}
		
		

	/**
	 *	 This method is used for reading bytes from the memory. You must
	 * call this function if you want to access some parts of memory such
	 * as locations where Atari custom chips are mapped. 
	 *
	 * The Atari custom chips (all except the new PIA in XL/XE models)
	 * do NOT fuly decode their address. So if you don't want to access
	 * the memory directly, use this method it will tell you the right 
	 * values.
	 *
	 * @param   address  location of reading
	 * @return     byte from the specified address
	 */
		public int getByte(int address) {
				int ret = 0;
				//System.out.print("Reading : "+address+" : ");
			

				if (attrib[address] == HW) {
					ret = getByteAtari (address);
				 //getByteAtari (address);
				} else {
					ret = mem[address] & 0xff;
				}
				
				//System.out.println(""+ret);
				
				return ret;
		}
	/**
	 * This similar to setRAM and setROM routines. It tells the computer
	 * where is the location of hardware registers.
	 *
	 * @param   from  start of the location
	 * @param   to  end of the location
	 */
		public void setHardware(int from, int to) {
				for (int i=from; i<=to; i++)
						attrib[i]=HW;
		}
		

	/**
	 *	 This method installs the specified Atari Operating System.
	 * The system is specified with OS_TYPE parameter. You can use
	 * the following predefined constants in AtariMem: OS_A, OS_B
	 * and OS_XL. Theese are the static values. Any other value will
	 * cause the hardware to crash. Files which represents theese
	 * OS's must have the following names : "./atariosa.rom", 
	 * "./atariosb.rom" and "./atarixl.rom" ( if you didn't already
	 * redefined them from outside).
	 *
	 * @param   OS_TYPE  specifies the operatring system to use.
	 */
	
		public void installAtariOS(int OS_TYPE) {
			switch (OS_TYPE) {
				case OS_A:
					try {
						installDataBlock(0xd800, 0xffff, OS [OS_A] );
					}
					catch (IOException e) {
						System.out.println("installAtariOS(): can't load "+ OS [OS_A]);
						System.exit(1);
					}

					setROM(0xd800, 0xffff);
					actualOS = OS_A;
					break;
						
				case OS_B:
					try {
						installDataBlock(0xd800, 0xffff, OS [OS_B]);
					}
					catch (IOException e) {
						System.out.println("installAtariOS(): can't load "+ OS [OS_B]);
						System.exit(1);
					}

					setROM(0xd800, 0xfff);
					actualOS = OS_B;
					break;
						
				case OS_XL:
					try  {
						installDataBlock(0xc000, 0xffff, OS [OS_XL]);
					}
					catch (IOException e) {
						System.out.println("installAtariOS(): can't load "+ OS [OS_XL]);
						System.exit(1);
					}

					for (int i=0; i<16384; i++)
						atarixl_os[i] = mem[0xc000+i];
								
					setROM(0xc000, 0xffff);
					actualOS = OS_XL;
					break;
						
				default:
					System.out.println("FATAL_ERROR: Can't load OS!");
					System.exit(1);	
					break;
			}
			
			setHardware(0xd000, 0xd7ff);
		}
		
		
		public void installBasic() {
				try  {
					installDataBlock(0xa000, 0xbfff, BASIC);
				}
				catch (IOException e) {
					System.out.println("installBasic(): can't load "+ BASIC);
					System.exit(1);
				}
				
				System.out.println("0xbffc: "+mem[0xbffc]);
				for (int i=0; i<8192; i++) {
					atari_basic[i] = mem[0xa000+i];
					if (i==0x1ffc) 
						System.out.println("basic="+atari_basic[i]+"  mem="+mem[0xc000+i]);
				}
				
				System.out.println("install() : "+atari_basic[0x1ffc]);
				setROM(0xa000, 0xbfff);
		}
		

	/**
	 * This "illegal" instruction hooks methods to OS through the
	 * escape codes. 
	 *
	 * @param   address  the address in memory where to store the 
	 					escape instruction. 
	 * @param   esc_code  the second parameter of escape is the escape code.
						What method (action) will be taken depends on its value.
	 */
		public void addEscape(int address, int esc_code) {
			System.out.println("Adding ESC @ "+address+" ESCCODE="+esc_code);
			writeMem (address, 0xff);				/* ESC */
			writeMem (address+1, esc_code);	/* ESC CODE */
  			writeMem (address+2, 0x60);			/* RTS */
  			
  			if (address==0xe459) {	// SIO
  					System.out.println("Byte @ 0xe459 (SIO) : "+getByte(0xe459));
  			}
		}
		
		

	/**
	 *	 This is a little bit hack, because we don't want to test
	 * the "memory" and we want to patch the HATABS table to point
	 * to our methods which emulate some devices for the Atari OS.
	 *
	 */
		public void patchOS() {
				// another good stuff, enjoy it!
				int addr, devtab, entry;
				
				final int 	o_open = 0;
			  	final int 	o_close = 2;
  				final int 	o_read = 4;
  				final int 	o_write = 6;
  				final int		o_status = 8;
  				final int 	o_special = 10;
  				final int		o_init = 12;

				
				addEscape(0xe459, ESC_SIO);

				if (actualOS == OS_XL) {				
					// disble the checksum test in XL/XE systems
					writeMem(0xc314, 0x8e);
					writeMem(0xc315, 0xff);
      				writeMem(0xc319, 0x8e);
      				writeMem(0xc31a, 0xff);
      				
      				addr = 0xc42e;
				} else {
					addr = 0xf0e3;
				}
				
										
				for (int i=0; i<=5; i++) {
					// Modify HATABS table
					devtab = (getByte(addr+2) << 8) | getByte(addr+1);
				
					switch (getByte (addr)) {
						case 'P' :
					  		break;
						case 'C' :
							putByte (addr, 'H');
							entry = getWord (devtab + o_open);
	  						addEscape (entry+1, ESC_H_OPEN);
	  						entry = getWord (devtab + o_close);
	  						addEscape (entry+1, ESC_H_CLOSE);
	  						entry = getWord (devtab + o_read);
	  						addEscape (entry+1, ESC_H_READ);
	  						entry = getWord (devtab + o_write);
	  						addEscape (entry+1, ESC_H_WRITE);
	  						entry = getWord (devtab + o_status);
	  						addEscape (entry+1, ESC_H_STATUS);
	  						break;
	  						
						case 'S':
							break;
	  							
						case 'K':
							/* Only for testing purposes
							entry = getWord (devtab + o_read);
						  	addEscape (entry+1, ESC_K_READ);
						  	*/
  							break;
		  							
  						default:
  							break;
						}
						addr += 3;
						
				}
				
		}
}
