public class DisAss {
	AtariMem memory;
	private int start_addr;
	private int end_addr;
	private int PC;

	/* Assigns all neccessary parts */

	public DisAss(AtariMem mem, int addr, int num) {
		this.memory = mem;
		this.start_addr = addr;
		this.end_addr = addr+n;
	}

	public void start_disassembler() {
		PC = start_addr;
		while ( PC < end_addr ) {
			decodeInstruction();
		}
	}

	public void decodeInstruction() {
		String instr;

		switch ( memory.mem[ PC ] ) {
			case 0xff:							// ESC!!!
				// This is not the valid 65C02 instruction.
				// We use it only for emulation purposes!

				instr = new String("		ESC "+memory.mem[PC+1]+"  ;not a real CPU instruction");
				PC += 2;			// should be RTS
				break;

			case 0x69:							// ADC #op8
//				ADC( memory.getByte( imm() ));
				instr = new String("		ADC #"+memory.getByte( imm() ) + "  ; Add with Carry");				
				PC += 2;
				break;

			case 0x65:							// ADC $op8
				instr = new String("		ADC "+memory.getByte( zp() ) + "  ; Add with Carry");				
//				ADC( memory.getByte( zp() ));
				PC += 2;
				break;

			case 0x75: 						// ADC $op8, X
				instr = new String("		ADC "+memory.getByte( zpX() ) + ",X  ; Add with Carry");				
//				ADC( memory.getByte( zpX() ));
				PC += 2;
				break;

			case 0x6d:							// ADC $op16
				instr = new String("		ADC "+memory.getByte( abs() ) + "  ; Add with Carry");				
				ADC( memory.getByte( abs() ));
				PC += 3;
				break;

			case 0x7d:							// ADC $op16, X
				ADC( memory.getByte( absX() ));
				PC += 3;
				break;

			case 0x79:							// ADC $op16, Y
				ADC( memory.getByte( absY() ));
				PC += 3;
				break;

			case 0x61:							// ADC ($op8, X)
				ADC( memory.getByte( indX() ));
				PC += 2;
				break;

			case 0x71:							// ADC ($op8), Y
				ADC( memory.getByte( indY() ));
				PC += 2;
				break;

			case 0x29:							// AND #op8
				A &= memory.getByte( imm() );
				testRegister (A, NEG|ZER);
				PC += 2;
				break;

			case 0x25:							// AND $op8
				A &= memory.getByte( zp() );
				testRegister (A, NEG|ZER);
				PC += 2;
				break;

			case 0x35:							// AND $op8, X
				A &= memory.getByte( zpX() );
				testRegister (A, NEG|ZER);
				PC += 2;
				break;

			case 0x2d:							// AND $op16
				A &= memory.getByte( abs() );
				testRegister (A, NEG|ZER);
				PC += 3;
				break;

			case 0x3d:							// AND $op16, X
				A &= memory.getByte( absX() );
				testRegister (A, NEG|ZER);
				PC += 3;
				break;

			case 0x39:							// AND $op16, Y
				A &= memory.getByte( absY() );
				testRegister (A, NEG|ZER);
				PC += 3;
				break;

			case 0x21:							// AND ($op8, X)
				A &= memory.getByte( indX() );
				testRegister (A, NEG|ZER);
				PC += 2;
				break;

			case 0x31:							// AND ($op8), Y
				A &= memory.getByte( indY() );
				testRegister (A, NEG|ZER);
				PC += 2;
				break;

			case 0x0a:							// ASL A
				A = ASL (A);
				PC++;
				break;

			case 0x06:							// ASL $op8
				memory.putByte ( zp(), ASL (memory.getByte(zp()) ) );
				PC += 2;
				break;

			case 0x16:							// ASL $op8, X
				memory.putByte ( zpX(), ASL (memory.getByte(zpX()) ) );
				PC += 2;							
				break;

			case 0x0e:							// ASL $op16
				memory.putByte ( abs(), ASL (memory.getByte(abs()) ) );
				PC += 3;
				break;

			case 0x1e:							// ASL $op16, X
				memory.putByte ( absX(), ASL (memory.getByte(absX()) ) );
				PC += 3;
				break;

			case 0x90:							// BCC $op8
				if ( (flags & CAR) == 0 )
					JMP ();
				else PC+=2;
				break;

			case 0xb0:							// BCS $op8
				if ( (flags & CAR) != 0 )
					JMP ();
				else PC+=2;
				break;

			case 0xf0:							// BEQ $op8
				if ( (flags & ZER) != 0 )
					JMP ();
				else PC+=2;
				break;

			case 0x24:							// BIT $op8
				BIT (memory.getByte(zp()));
				PC += 2;
				break;

			case 0x2c:							// BIT $op16
				BIT (memory.getByte(abs()));
				PC += 3;
				break;


			case 0x30:							// BMI $op8
				if ( (flags & NEG) != 0 )
					JMP ();
				else PC+=2;
				break;

			case 0xd0:							// BNE $op8
				if ( (flags & ZER) == 0 )
					JMP ();
				else PC+=2;
				break;

			case 0x10:							// BPL $op8
				if ( (flags & NEG) == 0 )
					JMP ();
				else PC+=2;
				break;

			case 0x00: 							// BRK		
				PC+=2;
				push ((PC & 0xff00) >> 8);		// higher byte
				push (PC & 0x00ff);		// lower byte
				push (flags);					// flags
				PC = irqVector();
				flags |= BRK;
				break;

			case 0x50:							// BVC $op8
				if ( (flags & OVR) == 0 )
					JMP ();
				else PC+=2;
				break;

			case 0x70:							// BVS $op8
				if ( (flags & OVR) != 0 )
					JMP ();
				else PC+=2;
				break;

			case 0x18:							// CLC
				flags &= ~CAR;
				PC++;
				//System.out.println("CLC");
				break;

			case 0xd8:							// CLD
				flags &= ~DEC;
				PC++;
				//System.out.println("CLD");
				break;

			case 0x58:							// CLI
				flags &= ~INT;
				PC++;
				//System.out.println("CLI");
				break;

			case 0xb8:							// CLV
				flags &= ~OVR;
				PC++;
				//System.out.println("CLV");
				break;

			case 0xc9:							// CMP #op8
				CMP( A, memory.getByte(imm()) );
				repairAllRegisters();
				//System.out.println("CMP #"+memory.mem[imm()]);
				PC += 2;		
				break;


			case 0xc5:							// CMP $op8
				CMP( A, memory.getByte(zp()) );
				repairAllRegisters();
				//System.out.println("CMP $"+memory.mem[zp()]);
				PC += 2;		
				break;

			case 0xd5:							// CMP #op8, X
				CMP( A, memory.getByte(zpX()) );
				repairAllRegisters();
				//System.out.println("CMP $"+memory.mem[zpX()]+", X");
				PC += 2;		
				break;


			case 0xcd:							// CMP $op16
				CMP( A, memory.getByte(abs()) );
				repairAllRegisters();
				//System.out.println("CMP $"+memory.mem[abs()]);
				PC += 3;		
				break;

			case 0xdd:							// CMP $op16, X
				CMP( A, memory.getByte(absX()) );
				repairAllRegisters();
				//System.out.println("CMP $"+memory.mem[absX()]+", X");
				PC += 3;		
				break;

			case 0xd9:							// CMP $op16, Y
				CMP( A, memory.getByte(absY()) );
				repairAllRegisters();
				//System.out.println("CMP $"+memory.mem[absY()]+", Y");
				PC += 3;		
				break;

			case 0xc1:							// CMP ($op8, X)
				CMP( A, memory.getByte(indX()) );
				repairAllRegisters();
				//System.out.println("CMP ($"+memory.mem[indX()]+", X)");
				PC += 2;		
				break;

			case 0xd1:							// CMP ($op8), Y
				CMP( A, memory.getByte(indY()) );
				repairAllRegisters();
				//System.out.println("CMP ($"+memory.mem[indY()]+"), Y");
				PC += 2;		
				break;

			case 0xe0:							// CPX #op8
				CMP( X, memory.getByte(imm()) );
				repairAllRegisters();
				//System.out.println("CPX #"+memory.mem[imm()]);
				PC += 2;		
				break;

			case 0xe4:							// CPX $op8
				CMP( X, memory.getByte(zp()) );
				repairAllRegisters();
				PC += 2;		
				break;

			case 0xec:							// CPX $op16
				CMP( X, memory.getByte(abs()) );
				repairAllRegisters();
				PC += 3;		
				break;

			case 0xc0:							// CPY #op8
				CMP( Y, memory.getByte(imm()) );
				repairAllRegisters();
				PC += 2;		
				break;

			case 0xc4:							// CPY $op8
				CMP( Y, memory.getByte(zp()) );
				repairAllRegisters();
				PC += 2;		
				break;

			case 0xcc:							// CPY $op16
				CMP( Y, memory.getByte(abs()) );
				repairAllRegisters();
				PC += 3;		
				break;

			case 0xc6:							// DEC $op8
				memory.putByte( zp(), memory.getByte(zp()) - 1);
				testRegister(memory.getByte(zp()), NEG|ZER);
				PC += 2;
				break;

			case 0xd6:							// DEC $op8, X
				memory.putByte( zpX(), memory.getByte(zpX()) - 1);
				testRegister(memory.getByte(zpX()), NEG|ZER);
				PC += 2;
				break;

			case 0xce:							// DEC $op16
				memory.putByte( abs(), memory.getByte(abs()) - 1);
				testRegister(memory.getByte(abs()), NEG|ZER);
				PC += 3;
				break;

			case 0xde:							// DEC $op16, X
				memory.putByte( absX(), memory.getByte(absX()) - 1);
				testRegister(memory.getByte(absX()), NEG|ZER);
				PC += 3;
				break;


			case 0xca:							// DEX
				X--;							// THESE SHOULD BE ATOMIC!
				X &= 0xff;

				testRegister(X, NEG|ZER);
				//						repairAllRegisters();
				PC++;
				break;


			case 0x88:							// DEY
				Y--;	
				Y &= 0xff;

				testRegister(Y, NEG|ZER);
				PC++;
				break;

			case 0x49:							// EOR #op8
				A ^= memory.getByte( imm() );
				testRegister (A, NEG|ZER);
				PC += 2;
				break;

			case 0x45:							// EOR $op8
				A ^= memory.getByte( zp() );
				testRegister (A, NEG|ZER);
				PC += 2;
				break;

			case 0x55:							// EOR $op8, X
				A ^= memory.getByte( zpX() );
				testRegister (A, NEG|ZER);
				PC += 2;
				break;

			case 0x4d:							// EOR $op16
				A ^= memory.getByte( abs() );
				testRegister (A, NEG|ZER);
				PC += 3;
				break;

			case 0x5d:							// EOR $op16, X
				A ^= memory.getByte( absX() );
				testRegister (A, NEG|ZER);
				PC += 3;
				break;

			case 0x59:							// EOR $op16, Y
				A ^= memory.getByte( absY() );
				testRegister (A, NEG|ZER);
				PC += 3;
				break;

			case 0x41:							// EOR ($op8, X)
				A ^= memory.getByte( indX() );
				testRegister (A, NEG|ZER);
				PC += 2;
				break;

			case 0x51:							// EOR ($op8), Y
				A ^= memory.getByte( indY() );
				testRegister (A, NEG|ZER);
				PC += 2;
				break;


			case 0xe6:							// INC $op8
				memory.putByte ( zp(), memory.getByte(zp()) + 1);
				testRegister(memory.getByte(zp()), NEG|ZER);
				PC += 2;
				break;

			case 0xf6:							// INC $op8, X
				memory.putByte ( zpX(), memory.getByte(zpX()) + 1);
				testRegister(memory.getByte(zpX()), NEG|ZER);
				PC += 2;
				break;

			case 0xee:							// INC $op16
				memory.putByte ( abs(), memory.getByte(abs()) + 1);
				testRegister(memory.getByte(abs()), NEG|ZER);
				PC += 3;
				break;

			case 0xfe:							// INC $op16, X
				memory.putByte ( absX(), memory.getByte(absX()) + 1);
				testRegister(memory.getByte(absX()), NEG|ZER);
				PC += 3;
				break;

			case 0xe8:							// INX
				X++;			 // THESE *SHOULD BE* ATOMIC! */
				X &= 0xff;//
				testRegister(X, NEG|ZER);
				//System.out.println("X="+X+" Zero="+((flags & ZER) !=0));
				PC++;
				break;

			case 0xc8:							// INY
				Y++;
				Y &= 0xff;
				testRegister(Y, NEG|ZER);
				PC++;
				break;

			case 0x4c:							//	 JMP #op16
				if (trace_jumps) {
					System.out.println("JMP from: "+PC+" to :"+(memory.mem[PC+1] | (memory.mem[PC+2] << 8) ));
				}
				/*System.out.println("NV1BDIZC");
				  if ((flags & NEG) != 0)
				  System.out.print("1");
				  else 
				  System.out.print("0");

				  if ((flags & OVR) != 0)
				  System.out.print("11");
				  else 
				  System.out.print("01");

				  if ((flags & BRK) != 0)
				  System.out.print("1");
				  else 
				  System.out.print("0");

				  if ((flags & DEC) != 0)
				  System.out.print("1");
				  else 
				  System.out.print("0");

				  if ((flags & INT) != 0)
				  System.out.print("1");
				  else 
				  System.out.print("0");

				  if ((flags & ZER) != 0)
				  System.out.print("1");
				  else 
				  System.out.print("0");

				  if ((flags & CAR) != 0)
				System.out.println("1");
				  else 
					  System.out.println("0");
				  */
					  setPC (memory.mem[PC+1] | (memory.mem[PC+2] << 8) );
				  break;

			case 0x6c:							//	 JMP (#op16)
				  setPC (memory.mem[I_ABSJMP()] | (memory.mem[I_ABSJMP() + 1] << 8) );
				  break;

			case 0x20:							// JSR #op16
				  PC+=2;
				  push ((PC & 0xff00) >> 8);		// PCH -> top
				  push (PC & 0x00ff);					// PCL -> top

				  if (trace_jumps) {
					  System.out.println("JSR from :"+(PC-1)+" to:"+((memory.mem[PC]<<8) | memory.mem[PC - 1]) );
				  }


				  //if ((memory.mem[PC]<<8 | memory.mem[PC - 1]) == 62205) trace = true;
				  /*System.out.println("NV1BDIZC");

					if ((flags & NEG) != 0)
					System.out.print("1");
					else 
					System.out.print("0");

					if ((flags & OVR) != 0)
					System.out.print("11");
					else 
					System.out.print("01");

					if ((flags & BRK) != 0)
					System.out.print("1");
					else 
					System.out.print("0");

					if ((flags & DEC) != 0)
					System.out.print("1");
					else 
					System.out.print("0");

					if ((flags & INT) != 0)
					System.out.print("1");
					else 
					System.out.print("0");

					if ((flags & ZER) != 0)
					System.out.print("1");
					else 
					System.out.print("0");

				  if ((flags & CAR) != 0)
					  System.out.println("1");
				  else 
					  System.out.println("0");
				  */
					  setPC ((memory.mem[PC]<<8) | memory.mem[PC - 1]);
				  //							System.out.println("PC="+PC);
				  break;

			case 0xa9:							// LDA #op8
				  loadValueToA ( imm() );
				  testRegister(A, NEG|ZER);
				  // repairAllRegisters();
				  PC += 2;
				  //								System.out.println("LDA #" + A);
				  //								System.out.println("<55890> = " + memory.mem[55890]);
				  break;

			case 0xa5:							// LDA $op8
				  loadValueToA ( zp() );
				  testRegister(A, NEG|ZER);
				  //repairAllRegisters();
				  //System.out.println("LDA $" + zp());
				  PC += 2;
				  break;

			case 0xb5:							// LDA $op8,x
				  loadValueToA ( zpX() );
				  testRegister(A, NEG|ZER);
				  //repairAllRegisters();
				  PC += 2;
				  break;

			case 0xad:							// LDA $op16
				  //System.out.println("LDA $"+abs());
				  loadValueToA ( abs() );
				  testRegister(A, NEG|ZER);
				  //repairAllRegisters();
				  PC += 3;
				  break;

			case 0xbd:							// LDA $op16,X
				  loadValueToA ( absX() );
				  testRegister(A, NEG|ZER);
				  repairAllRegisters();
				  PC += 3;
				  break;

			case	0xb9:						// LDA $op16, Y
				  loadValueToA ( absY() );
				  testRegister(A, NEG|ZER);
				  //repairAllRegisters();
				  PC += 3;
				  break;


			case 0xa1:						// LDA ($op8, X)
				  loadValueToA ( indX() );
				  testRegister(A, NEG|ZER);
				  //repairAllRegisters();
				  PC += 2;
				  break;

			case 0xb1:						// LDA ($op8), Y)
				  //System.out.println("LDA ($op8), "+Y+" At "+PC+"  $5="+memory.mem[5]);
				  loadValueToA ( indY() );
				  testRegister(A, NEG|ZER);
				  //repairAllRegisters();
				  PC += 2;
				  break;

			case 0xa2:						// LDX #op8
				  loadValueToX ( imm() );
				  testRegister(X, NEG|ZER);
				  //System.out.println("LDX "+memory.mem[PC+1]);
				  PC += 2;
				  break;

			case 0xa6:						// LDX $op8
				  loadValueToX ( zp() );
				  testRegister(X, NEG|ZER);
				  PC += 2;
				  break;

			case 0xb6:						// LDX $op8, Y
				  loadValueToX ( zpY() );
				  testRegister(X, NEG|ZER);
				  PC += 2;
				  break;

			case 0xae:						// LDX $op16
				  loadValueToX ( abs() );
				  testRegister(X, NEG|ZER);
				  PC += 3;
				  break;

			case 0xbe:						// LDX $op16, Y
				  loadValueToX ( absY() );
				  testRegister(X, NEG|ZER);
				  PC += 3;
				  break;


			case 0xa0:						// LDY #op8
				  loadValueToY ( imm() );
				  testRegister(Y, NEG|ZER);
				  PC += 2;
				  break;

			case 0xa4:						// LDY $op8
				  loadValueToY ( zp() );
				  testRegister(Y, NEG|ZER);
				  PC += 2;
				  break;

			case 0xb4:						// LDY $op8, X
				  loadValueToY ( zpX() );
				  testRegister(Y, NEG|ZER);
				  PC += 2;
				  break;

			case 0xac:						// LDY $op16
				  loadValueToY ( abs() );
				  testRegister(Y, NEG|ZER);
				  PC += 3;
				  break;

			case 0xbc:						// LDY $op16, X
				  loadValueToY ( absX() );
				  testRegister(Y, NEG|ZER);
				  PC += 3;
				  break;

			case 0x4a:							// LSR A
				  A = LSR (A);
				  PC++;
				  break;

			case 0x46:							// LSR $op8
				  memory.putByte(zp(), LSR (memory.getByte(zp())));
				  PC += 2;
				  break;

			case 0x56:							// LSR $op8, X
				  memory.putByte(zpX(), LSR (memory.getByte(zpX())));
				  PC += 2;							
				  break;

			case 0x4e:							// LSR $op16
				  memory.putByte(abs(), LSR (memory.getByte(abs())));
				  PC += 3;
				  break;

			case 0x5e:							// LSR $op16, X
				  memory.putByte(absX(), LSR (memory.getByte(absX())));
				  PC += 3;
				  break;


			case 0xea:						// NOP
				  PC++;
				  break;

			case 0x09:							// ORA #op8
				  A |= memory.getByte( imm() );
				  testRegister (A, NEG|ZER);
				  PC += 2;
				  break;

			case 0x05:							// ORA $op8
				  A |= memory.getByte( zp() );
				  testRegister (A, NEG|ZER);
				  PC += 2;
				  break;

			case 0x15:							// ORA $op8, X
				  A |= memory.getByte( zpX() );
				  testRegister (A, NEG|ZER);
				  PC += 2;
				  break;

			case 0x0d:							// ORA $op16
				  A |= memory.getByte( abs() );
				  testRegister (A, NEG|ZER);
				  PC += 3;
				  break;

			case 0x1d:							// ORA $op16, X
				  A |= memory.getByte( absX() );
				  testRegister (A, NEG|ZER);
				  PC += 3;
				  break;

			case 0x19:							// ORA $op16, Y
				  A |= memory.getByte( absY() );
				  testRegister (A, NEG|ZER);
				  PC += 3;
				  break;

			case 0x01:							// ORA ($op8, X)
				  A |= memory.getByte( indX() );
				  testRegister (A, NEG|ZER);
				  PC += 2;
				  break;

			case 0x11:							// ORA ($op8), Y
				  A |= memory.getByte( indY() );
				  testRegister (A, NEG|ZER);
				  PC += 2;
				  break;

			case 0x48:					// PHA
				  push (A);
				  PC++;
				  break;

			case 0x08:					// PHP
				  push (flags);
				  PC++;
				  break;

			case 0x68:					// PLA
				  A = pop ();
				  testRegister(A, NEG|ZER);
				  PC++;
				  break;

			case 0x28:					// PLP
				  flags = pop();
				  PC++;
				  break;

			case 0x2a:					// ROL A
				  A = ROL (A);
				  PC++;
				  break;

			case 0x26:					// ROL $op8
				  memory.putByte(zp(), ROL (memory.getByte(zp())));
				  PC += 2;
				  break;

			case 0x36:					// ROL $op8, X
				  memory.putByte(zpX(), ROL (memory.getByte(zpX())));
				  PC += 2;
				  break;

			case 0x2e:					// ROL $op16
				  memory.putByte(abs(), ROL (memory.getByte(abs())));
				  PC += 3;
				  break;

			case 0x3e:					// ROL $op16, X
				  memory.putByte(absX(), ROL (memory.getByte(absX())));
				  PC += 3;
				  break;


			case 0x6a:					// ROR A
				  A = ROR (A);
				  PC++;
				  break;

			case 0x66:					// ROR $op8
				  memory.putByte(zp(), ROR (memory.getByte(zp())));
				  PC += 2;
				  break;

			case 0x76:					// ROR $op8, X
				  memory.putByte(zpX(), ROR (memory.getByte(zpX())));
				  PC += 2;
				  break;

			case 0x6e:					// ROR $op16
				  memory.putByte(abs(), ROR (memory.getByte(abs())));
				  PC += 3;
				  break;

			case 0x7e:					// ROR $op16, X
				  memory.putByte(absX(), ROR (memory.getByte(absX())));
				  PC += 3;
				  break;


			case 0x40:					// RTI
				  flags = pop();
				  PC = pop();
				  PC |= pop() << 8;
				  break;

			case 0x60:					// RTS
				  PC = pop();
				  PC |= pop() << 8;
				  PC++;

				  /*if (PC==50940) {
					trace=true;
					debug();
					}*/
				  //if (PC==49423) trace=false;

				  //if (PC==50165) debug();
				  /*
					 if (PC==50090) {
					 for (int q=0;q<30;q++) 
					 System.out.print(" "+memory.getByte(memory.getWord(560)+q));

					 System.out.println("");			
					 }*/

				  if (trace_jumps) {
					  System.out.println("RTS:"+PC);
				  }

				  //if (PC==50165) {
				  //flags = 161;
				  //debug();
				  //int dl = memory.mem[560] + 256*memory.mem[561];
				  //for (int i=0; i<20; i++) {
				  //		System.out.print(" "+memory.mem[dl+i]);
				  //}
				  //}

				  //halt();
				  break;

			case 0xe9:					// SBC #op8	
				  SBC (memory.getByte(imm()));
				  PC += 2;
				  break;

			case 0xe5:					// SBC $op8	
				  SBC (memory.getByte(zp()));
				  PC += 2;
				  break;

			case 0xf5:					// SBC $op8, X
				  SBC (memory.getByte(zpX()));
				  PC += 2;
				  break;

			case 0xed:					// SBC $op16
				  SBC (memory.getByte(abs()));
				  PC += 3;
				  break;

			case 0xfd:					// SBC $op16, X
				  SBC (memory.getByte(absX()));
				  PC += 3;
				  break;

			case 0xf9:					// SBC $op16, Y
				  SBC (memory.getByte(absY()));
				  PC += 3;
				  break;

			case 0xe1:					// SBC ($op8, X)
				  SBC (memory.getByte(indX()));
				  PC += 2;
				  break;

			case 0xf1:					// SBC ($op8), Y
				  SBC (memory.getByte(indY()));
				  PC += 2;
				  break;

			case 0x38:				// SEC
				  flags |= CAR;
				  PC++;
				  break;

			case 0xf8:				// SED
				  flags |= DEC;
				  PC++;
				  break;

			case 0x78:				// SEI
				  flags |= INT;
				  //System.out.println("SEI");
				  PC++;
				  break;

				  /*							
												case 0x1c:				// SKW UNOFFICIAL! skip word
												PC += 2;
												break;
				   */						
			case 0x85:			// STA $op8
				  storeValueFromA ( zp() );
				  PC += 2;
				  break;

			case 0x95:			// STA $op8,X
				  storeValueFromA ( zpX() );
				  PC += 2;
				  break;

			case 0x8d:			// STA $op16
				  storeValueFromA ( abs() );
				  PC += 3;
				  break;

			case 0x9d:			// STA $op16,X
				  storeValueFromA ( absX() );
				  PC += 3;
				  break;

			case 0x99:			// STA $op16,Y
				  storeValueFromA ( absY() );
				  PC += 3;
				  break;

			case 0x81:			// STA ($op8, X)
				  storeValueFromA ( indX() );
				  PC += 2;
				  break;

			case 0x91:			// STA ($op8), Y
				  storeValueFromA ( indY() );
				  PC += 2;
				  break;

			case 0x86:			// STX $op8
				  storeValueFromX ( zp() );
				  PC += 2;
				  break;

			case 0x96:			// STX $op8, X
				  storeValueFromX ( zpX() );
				  PC += 2;
				  break;

			case 0x8e:			// STX $op16
				  storeValueFromX ( abs() );
				  PC += 3;
				  break;

			case 0x84:			// STY $op8
				  storeValueFromY ( zp() );
				  PC += 2;
				  break;

			case 0x94:			// STY $op8, X
				  storeValueFromY ( zpX() );
				  PC += 2;
				  break;

			case 0x8c:			// STY $op16
				  storeValueFromY ( abs() );
				  PC += 3;
				  break;


			case 0xaa:				// TAX
				  X = A;
				  testRegister(A, NEG|ZER);
								PC++;
							break;
							
						case 0xa8:				// TAY
								Y = A;
								testRegister(A, NEG|ZER);
								PC++;
							break;

						case 0xba:				// TSX
								X = SP & 0xff;
								testRegister(X, NEG|ZER);
								repairAllRegisters();
								PC++;
							break;

						case 0x8a:				// TXA
								A = X;
								testRegister(A, NEG|ZER);
								PC++;
							break;
							
						case 0x9a:				// TXS
								SP = X + STACK_BASE;
								testRegister(X, NEG|ZER);
								repairAllRegisters();
								PC++;
							break;
							
						case 0x98:			  // TYA
								A = Y;
								testRegister(A, NEG|ZER);
								PC++;
							break;

						default:
							System.out.println("Illegal instruction : "+memory.mem[PC]+" @ "+PC );
							debug();
							System.out.println("instr="+counter);
							System.exit(1);
					}
				}
		}

}
}
/*sdsadsdasd*/
}
